=== modified file 'source/NVDAObjects/window/winword.py'
--- source/NVDAObjects/window/winword.py	2013-03-26 01:42:05 +0000
+++ source/NVDAObjects/window/winword.py	2013-04-04 11:56:26 +0000
@@ -25,6 +25,7 @@
 import controlTypes
 from . import Window
 from ..behaviors import EditableTextWithoutAutoSelectDetection
+import keyboardHandler
  
 #Word constants
 
@@ -477,6 +478,11 @@
 
 	def script_previousColumn(self,gesture):
 		self._moveInTable(row=False,forward=False)
+		
+	def script_heading(self,gesture):
+		#gesture.send()
+		keyboardHandler.KeyboardInputGesture.fromName("Alt+h").send()
+		keyboardHandler.KeyboardInputGesture.fromName("l").send()
 
 	__gestures = {
 		"kb:tab": "tab",
@@ -487,5 +493,6 @@
 		"kb:control+alt+rightArrow": "nextColumn",
 		"kb:control+pageUp": "caret_moveByLine",
 		"kb:control+pageDown": "caret_moveByLine",
+		"kb:NVDA+h": "heading",
 	}
 

=== modified file 'source/globalCommands.py'
--- source/globalCommands.py	2013-03-20 07:31:28 +0000
+++ source/globalCommands.py	2013-03-15 10:15:48 +0000
@@ -457,16 +457,15 @@
 			pass
 		obj=api.getNavigatorObject()
 		while obj:
-			realActionName=actionName
-			try:
-				realActionName=obj.getActionName()
-			except:
-				pass
 			try:
 				obj.doAction()
 				if isinstance(gesture,touchHandler.TouchInputGesture):
 					touchHandler.handler.notifyInteraction(obj)
-				ui.message(realActionName)
+				try:
+					actionName=obj.getActionName()
+				except NotImplementedError:
+					pass
+				ui.message(actionName)
 				return
 			except NotImplementedError:
 				pass
@@ -1066,43 +1065,6 @@
 		ui.message(_("Plugins reloaded"))
 	script_reloadPlugins.__doc__=_("Reloads app modules and global plugins without restarting NVDA, which can be Useful for developers")
 
-	def script_navigatorObject_nextInFlow(self,gesture):
-		curObject=api.getNavigatorObject()
-		newObject=None
-		if curObject.simpleFirstChild:
-			newObject=curObject.simpleFirstChild
-		elif curObject.simpleNext:
-			newObject=curObject.simpleNext
-		elif curObject.simpleParent:
-			parent=curObject.simpleParent
-			while parent and not parent.simpleNext:
-				parent=parent.simpleParent
-			if parent:
-				newObject=parent.simpleNext
-		if newObject:
-			api.setNavigatorObject(newObject)
-			speech.speakObject(newObject,reason=controlTypes.REASON_FOCUS)
-		else:
-			# Translators: a message when there is no next object when navigating
-			ui.message(_("no next"))
-	script_navigatorObject_nextInFlow.__doc__=_("Moves to the next object in a flattened view of the object navigation hyrarchi")
-
-	def script_navigatorObject_previousInFlow(self,gesture):
-		curObject=api.getNavigatorObject()
-		newObject=curObject.simplePrevious
-		if newObject:
-			while newObject.simpleLastChild:
-				newObject=newObject.simpleLastChild
-		else:
-			newObject=curObject.simpleParent
-		if newObject:
-			api.setNavigatorObject(newObject)
-			speech.speakObject(newObject,reason=controlTypes.REASON_FOCUS)
-		else:
-			# Translators: a message when there is no next object when navigating
-			ui.message(_("no next"))
-	script_navigatorObject_previousInFlow.__doc__=_("Moves to the previous object in a flattened view of the object navigation hyrarchi")
-
 	def script_touch_changeMode(self,gesture):
 		mode=touchHandler.handler._curTouchMode
 		index=touchHandler.availableTouchModes.index(mode)
@@ -1165,12 +1127,10 @@
 		"ts(object):flickup":"navigatorObject_parent",
 		"kb:NVDA+numpad4": "navigatorObject_previous",
 		"kb(laptop):NVDA+shift+leftArrow": "navigatorObject_previous",
-		"ts(object):flickleft":"navigatorObject_previousInFlow",
-		"ts(object):2finger_flickleft":"navigatorObject_previous",
+		"ts(object):flickleft":"navigatorObject_previous",
 		"kb:NVDA+numpad6": "navigatorObject_next",
 		"kb(laptop):NVDA+shift+rightArrow": "navigatorObject_next",
-		"ts(object):flickright":"navigatorObject_nextInFlow",
-		"ts(object):2finger_flickright":"navigatorObject_next",
+		"ts(object):flickright":"navigatorObject_next",
 		"kb:NVDA+numpad2": "navigatorObject_firstChild",
 		"kb(laptop):NVDA+shift+downArrow": "navigatorObject_firstChild",
 		"ts(object):flickdown":"navigatorObject_firstChild",

